#include <bits/stdc++.h>


#define int long long
#define pii pair<int,int>
const int inf = 1e18 + 7;


using namespace std;
const int max_n = 10;
bitset<max_n> a[max_n];
int b[max_n][max_n];

bool check(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j)continue;
            bitset<max_n> b = a[i] ^a[j];
            vector<bool> c = {0, 0};
            for (int ind = 0; ind < m; ind++) {
                if (!b[ind]) {
                    if (c[a[i][ind]])return false;
                    c[a[i][ind]] = true;
                }
            }
        }
    }
    return true;
}

void solve(int n, int m) {
    int c = 1LL << (n * m);
    for (int mask = 0; mask < c; mask++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                int k = i * m + j;
                a[i][j] = (mask & (1LL << k));
            }
        }
        if (check(n, m)) {
            break;
        }
    }
}

void print(int n) {
    cout << "arr:\n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            cout << a[i][j] + 1 << " ";
        cout << '\n';
    }
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m, d;
    cin >> n >> m >> d;
    if (d == 3)n--, m--;
    int c = 1LL << (n * m);
    int val = 0;
    if (n < m) {
        for (int j = 0; j < m; j += n) {
            solve(n, n);
            /*print(n);*/
            for (int i = 0; i < n; i++) {
                for (int l = j; l < min(m, j + n); l++) {
                    b[i][j] = a[i][l - j];
                }
            }
        }
    } else {
        for (int j = 0; j < n; j += m) {
            solve(m, m);
            for (int i = j; i < min(n, j + m); i++) {
                for (int l = 0; l < m; l++) {
                    b[i][j] = a[i - j][l];
                }
            }
        }
    }
    if (d == 2) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++)
                cout << a[i][j] + 1 << " ";
            cout << "\n";
        }
        exit(0);
    }
    n++, m++;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int vall = b[i][j];
            if (i == n - 1 || j == m - 1)vall = 2;
            if (i == n - 1 && j == m - 1) vall = 1;
            cout << val + 1 << " ";
        }
        cout << "\n";
    }
}